#include <stdlib.h>
#include "hello.h"

extern CORBA_Object impl_hello__create(PortableServer_POA poa, CORBA_Environment * ev);

int
main (int argc, char *argv[])
{
  CORBA_Environment ev;
  CORBA_ORB orb;
  CORBA_Object obj;
  int fd[2];

  pipe(fd);

#ifndef TEST_IN_PROC
  if (fork())
#endif
    {
      PortableServer_POA poa;
      gchar* ior;

      CORBA_exception_init(&ev);
      orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
      poa = (PortableServer_POA) CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
      PortableServer_POAManager_activate (PortableServer_POA__get_the_POAManager(poa, &ev), &ev);
      obj = impl_hello__create(poa, &ev);
      ior = CORBA_ORB_object_to_string(orb, obj, &ev);
      write(fd[1], ior, strlen(ior)+1);
#ifndef TEST_IN_PROC
      CORBA_ORB_run(orb, &ev);
    }
  else
#else
    }
#endif
    {
      gchar* str;
      gchar ior[2048];
      CORBA_any* any;
      
      CORBA_exception_init(&ev);
      orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
      read(fd[0], ior, 2048);
      obj = CORBA_ORB_string_to_object(orb, ior, &ev);
      str = "Client says: 'Hola Mundo'";
      
      any = CORBA_any_alloc();
      any->_type = (CORBA_TypeCode)TC_CORBA_string;
      any->_value = &str;
      CORBA_any_set_release(any, CORBA_FALSE);
      
      hello_puts(obj, any, &ev);
    }
  exit(0);
}
